# 📸 Screenshot-Tool für Mitarbeiterschulungen

Automatisches Tool zur Erstellung von Screenshots aller Webseiten für Schulungszwecke und IHK-Präsentationen.

## 🚀 Schnellstart

### Windows (Empfohlen)
```batch
# Einfach per Doppelklick ausführen:
start_screenshot_tool.bat
```

### PowerShell
```powershell
.\run_screenshot_tool.ps1
```

### Python (Direkt)
```bash
python screenshot_tool.py
```

## 📁 Dateien

| Datei | Beschreibung |
|-------|--------------|
| `screenshot_tool.py` | Hauptprogramm (Python) |
| `screenshot_config.json` | Konfigurationsdatei |
| `run_screenshot_tool.ps1` | PowerShell-Skript |
| `start_screenshot_tool.bat` | Windows Batch-Datei (Ein-Klick-Start) |
| `README.md` | Diese Datei |

## ⚙️ Konfiguration

### Wichtige Einstellungen anpassen
```json
{
  "server": {
    "base_url": "http://localhost:5000",
    "admin_email": "admin@example.com",
    "admin_password": "admin123"
  }
}
```

## 📂 Ausgabe

Screenshots werden erstellt in:
```
docs/schulung/screenshots/
├── admin/          # Administrator-Bereich
│   ├── desktop/    # 1920x1080
│   ├── tablet/     # 1024x768
│   └── mobile/     # 375x667
├── benutzer/       # Benutzer-Bereich
└── oeffentlich/    # Öffentliche Seiten
```

## 🎯 Verwendung

### Für IHK-Präsentationen
- Desktop-Screenshots verwenden
- Admin-Ordner für System-Funktionen
- Strukturierte Ordner-Organisation

### Für Mitarbeiterschulungen
- Alle Auflösungen verfügbar
- Kategorisiert nach Benutzergruppen
- Automatische Berichte inklusive

## 🔧 Abhängigkeiten

```bash
pip install selenium webdriver-manager
```

## 📊 Berichte

Nach der Ausführung verfügbar:
- `screenshot_report.json` - Technischer Bericht
- `screenshot_bericht.md` - Menschenlesbarer Bericht

## 🆘 Support

Bei Problemen siehe: `../docs/SCHULUNG_SCREENSHOT_TOOL.md`

---
**Version**: 1.0 | **Datum**: 16.01.2025 