#!/usr/bin/env python3
# -*- coding: utf-8 -*-

from models import get_db_session, Printer

def aktiviere_alle_drucker():
    """Aktiviert alle Drucker in der Datenbank."""
    try:
        session = get_db_session()
        drucker = session.query(Printer).all()
        
        if not drucker:
            print("Keine Drucker in der Datenbank gefunden.")
            session.close()
            return
        
        print(f"Anzahl Drucker: {len(drucker)}")
        print("Aktiviere alle Drucker...")
        
        for d in drucker:
            d.active = True
            print(f"Drucker {d.id}: {d.name} - IP: {d.plug_ip} - Aktiv: {d.active}")
        
        session.commit()
        print("Alle Drucker wurden erfolgreich aktiviert!")
        session.close()
        
    except Exception as e:
        print(f"Fehler: {str(e)}")
        try:
            session.rollback()
            session.close()
        except:
            pass

if __name__ == "__main__":
    aktiviere_alle_drucker() 